--dofile("wmBot/log.lua")
dofile("wmBot/defs.lua")
dofile("wmBot/lib.lua")
dofile("wmBot/helpers.lua")
dofile("wmBot/files.lua")
dofile("wmBot/commands.lua")

function sendwelcome(user)
	local file = openfile("wmBot/welcome.txt", "r")			
	if file then
		local line = read(file)
		local text = ""
		while line do
			text = text.."\013\010"..line
			line = read(file)
		end
		closefile(file)
		local info = parseuserinfo(user.sMyInfoString)
		local vars = {
			uzivatel = user.sName,
			jmenohubu = frmHub:GetHubName(),
			wmbot = aboutinfo,
			botname = botname,
			pocetuzivatelu = frmHub:GetUsersCount(),
			maxuzivatelu = frmHub:GetMaxUsers(),
			share = format("%.2f", info.share / (1024 * 1024 * 1024))
		}
		text = replacevars(text, vars)
		if config.welcome == 1 then
			chatfor(user, text)
		elseif config.welcome == 2 then
			pm(user, text)
		end
	end
end

function install(user)
	local item = {
		name = user.sName,
		level = ownerlevel,
		rights = { }
	}
	for key, value in possrights do
		item.rights[key] = value
	end
	tinsert(ops.items, item)
	owner = getn(ops.items)
	saveops()
	pm(user, "Byl jste nastaven jako majitel hubu, skript je nyni pripraven prijmat prikazy.")
	installed = 1
end

function handlebotcmd(user, cmd)
	local name, f
	for name, f in commands do
		if strlower(strsub(cmd, 1, strlen(name))) == name and (strlen(cmd) == strlen(name) or strsub(cmd, strlen(name) + 1, strlen(name) + 1) == " ") then
			arg = strsub(cmd, strlen(name) + 2)
			-- odebrat mezery z konce a zacatku parametru
			while strsub(arg, 1, 1) == " " do
				arg = strsub(arg, 2)
			end
			while strsub(arg, strlen(arg)) == " " do
				arg = strsub(arg, 1, strlen(arg) - 1)
			end
			return f(user, arg)
		end			
	end
end

function recievedpm(user, text)
	if installed then
		if strsub(text, 1, 1) == "." then
			local cmd = strsub(text, 2)
			return handlebotcmd(user, cmd)
		else
			return handlebotcmd(user, text)
		end
	else
		if user.bOperator and text == config.installpw then
			install(user)
		end
	end
end

function recievedchat(user, text)
	if installed then
		if strsub(text, 1, 1) == "." then
			local cmd = strsub(text, 2)
			return handlebotcmd(user, cmd)
		else
			if config.capslockwarn then
				local c = 0
				local b
				local min, max = strbyte("A"), strbyte("Z")
				local go
				for i = 1, strlen(text) do
					b = strbyte(strsub(text, i, i)) 
					if (b >= min) and (b <= max) then
						c = c + 1
					end
					if c >= 5 then
						go = 1
						break
					end
				end
				if go then
					if strupper(text) == text then
						local vars = {
							uzivatel = user.sName
						}
						chat(replacevars(messages.capslock, vars))
					end
				end
			end
			local longestkey = ""
			for key, reply in phrases do				
				if strfind(" "..strlower(text).." ", key) then
					if strlen(key) > strlen(longestkey) then
						longestkey = key
					end
				end
			end
			if longestkey ~= "" then
				local reply = phrases[longestkey]
				local vars = {
					uzivatel = user.sName
				}
				reply = replacevars(reply, vars)
				chat(reply)
			end
		end
	end
end

function Main()
	chat("Spousti se "..aboutinfo.."...");
	frmHub:RegBot(botname)
	loadmessages()
	loadops()
	installed = (getn(ops.items) > 0)
	if installed then
		if getn(modules) >= 1 then
			modulehelp = ""
			for index, value in modules do
				dofile("wmBot/modules/"..value.."/module.lua")
			end
		end
		loadphrases()
	end
	chat("Hotovo.");
	if not installed then
		chat("Cekam na instalaci majitelem hubu.")
	end
end

function DataArrival(user, data)
	if strsub(data, 1, 1) == "<" then
		local s, e, text = strfind(data, "%<%S+%> (.*)|.*")
		local result = recievedchat(user, text)
		if result then
			chatfor(user, result)
		end
		if config.floodprotect == 1 then
			
		end
	elseif strsub(data, 1, 5) == "$To: " then
		local s, e, recipient = strfind(data, "%$To:%s*(%S+)%s*From:")
		if strlower(recipient) == strlower(botname) then
			local s, e, msg = strfind(data, "%$To:%s*%S+%s*From:%s*%S+%s*%$%<%S+%> (.*)|.*")
			if msg then
				local result = recievedpm(user, msg)
				if result then
					pm(user, result)
				end
			end
		end
	end
end

function NewUserConnected(user)
	if installed then
		if config.welcome > 0 then
			sendwelcome(user)
		end
	end
end

function OpConnected(user)
	if installed then
		if config.welcome > 0 then
			sendwelcome(user)
		end
		local vars = {
			jmeno = user.sName
		}
		chat(replacevars(messages.opconnected, vars))
	else
		pm(user, "Detekoval jsem prvni spusteni, pokud jste majitel hubu, poslete mi odblokovaci heslo na PM.")
	end
end

function OpDisconnected(user)
	if installed then
		vars = {
			jmeno = user.sName
		}
		chat(replacevars(messages.opdisconnected, vars))
	end
end